<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="企业全称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入企业全称" />
      </el-form-item>
      <el-form-item label="企业别称" prop="anotherName">
        <el-input v-model="formData.anotherName" placeholder="请输入企业别称" />
      </el-form-item>
      <el-form-item label="企业官网" prop="website">
        <el-input v-model="formData.website" placeholder="请输入企业官网" />
      </el-form-item>
      <el-form-item label="公司简介" prop="introduce">
        <el-input v-model="formData.introduce" placeholder="请输入公司简介" />
      </el-form-item>
      <el-form-item label="联系人" prop="contacts">
        <el-input v-model="formData.contacts" placeholder="请输入联系人" />
      </el-form-item>
      <el-form-item label="联系电话" prop="phone">
        <el-input v-model="formData.phone" placeholder="请输入联系电话" />
      </el-form-item>
      <el-form-item label="logo图片地址" prop="logoUrl">
        <el-input v-model="formData.logoUrl" placeholder="请输入logo图片地址" />
      </el-form-item>
      <el-form-item label="所在行业" prop="industryId">
        <el-select v-model="formData.industryId" placeholder="请选择所在行业">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="融资阶段" prop="financingStatus">
        <el-select v-model="formData.financingStatus" placeholder="请选择融资阶段">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_FINANCING_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="人员规模" prop="scale">
        <el-select v-model="formData.scale" placeholder="请选择人员规模">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_SCALE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="公司福利" prop="welfareList">
        <el-input v-model="formData.welfareList" placeholder="请输入公司福利" />
      </el-form-item>
      <el-form-item label="公司相册" prop="albumList">
        <el-input v-model="formData.albumList" placeholder="请输入公司相册" />
      </el-form-item>
      <el-form-item label="上班时间" prop="workTime">
        <el-date-picker
          v-model="formData.workTime"
          type="date"
          value-format="x"
          placeholder="选择上班时间"
        />
      </el-form-item>
      <el-form-item label="发展历程" prop="developHistory">
        <el-input v-model="formData.developHistory" placeholder="请输入发展历程" />
      </el-form-item>
      <el-form-item label="获得荣誉" prop="receivedHonors">
        <el-input v-model="formData.receivedHonors" placeholder="请输入获得荣誉" />
      </el-form-item>
      <el-form-item label="上级id" prop="parentId">
        <el-input v-model="formData.parentId" placeholder="请输入上级id" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { EnterpriseApi, EnterpriseVO } from '@/api/menduner/system/enterprise/message'

/** 门墩儿-企业信息 表单 */
defineOptions({ name: 'EnterpriseForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  anotherName: undefined,
  website: undefined,
  introduce: undefined,
  contacts: undefined,
  phone: undefined,
  logoUrl: undefined,
  industryId: undefined,
  financingStatus: undefined,
  scale: undefined,
  welfareList: undefined,
  albumList: undefined,
  workTime: undefined,
  developHistory: undefined,
  receivedHonors: undefined,
  parentId: undefined
})
const formRules = reactive({
  parentId: [{ required: true, message: '上级id不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EnterpriseApi.getEnterprise(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EnterpriseVO
    if (formType.value === 'create') {
      await EnterpriseApi.createEnterprise(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnterpriseApi.updateEnterprise(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    anotherName: undefined,
    website: undefined,
    introduce: undefined,
    contacts: undefined,
    phone: undefined,
    logoUrl: undefined,
    industryId: undefined,
    financingStatus: undefined,
    scale: undefined,
    welfareList: undefined,
    albumList: undefined,
    workTime: undefined,
    developHistory: undefined,
    receivedHonors: undefined,
    parentId: undefined
  }
  formRef.value?.resetFields()
}
</script>